FLTK 1.3.9: Fl_RGB_Image Class Reference

FLTK 1.3.9

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
Fl_RGB_Image Class Reference

The Fl_RGB_Image class supports caching and drawing of full-color images with 1 to 4 channels of color information. More...

`#include <Fl_Image.H>`

Inheritance diagram for Fl_RGB_Image:

## Public Member Functions
virtual void | color_average (Fl_Color c, float i)
| The color_average() method averages the colors in the image with the FLTK color value c.
Fl_Image * | copy ()
virtual Fl_Image * | copy (int W, int H)
| The copy() method creates a copy of the specified image.
virtual void | desaturate ()
| The desaturate() method converts an image to grayscale.
void | draw (int X, int Y)
virtual void | draw (int X, int Y, int W, int H, int cx=0, int cy=0)
| Draws the image with a bounding box.
| Fl_RGB_Image (const Fl_Pixmap *pxm, Fl_Color bg=FL_GRAY)
| The constructor creates a new RGBA image from the specified Fl_Pixmap.
| Fl_RGB_Image (const uchar *bits, int W, int H, int D=3, int LD=0)
| The constructor creates a new image from the specified data.
virtual void | label (Fl_Menu_Item *m)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item.
virtual void | label (Fl_Widget *w)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item.
virtual void | uncache ()
| If the image has been cached for display, delete the cache data.
virtual | ~Fl_RGB_Image ()
| The destructor frees all memory and server resources that are used by the image.
Public Member Functions inherited from Fl_Image
Fl_Image * | copy ()
| The copy() method creates a copy of the specified image.
int | count () const
| The count() method returns the number of data values associated with the image.
int | d () const
| Returns the current image depth.
const char *const * | data () const
| Returns a pointer to the current image data array.
void | draw (int X, int Y)
| Draws the image.
int | fail ()
| Returns a value that is not 0 if there is currently no image available.
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth.
int | h () const
| Returns the current image height in pixels.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.
int | ld () const
| Returns the current line data size in bytes.
int | w () const
| Returns the current image width in pixels.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Static Public Member Functions
static size_t | max_size ()
| Returns the maximum allowed image size in bytes when creating an Fl_RGB_Image object.
static void | max_size (size_t size)
| Sets the maximum allowed image size in bytes when creating an Fl_RGB_Image object.
Static Public Member Functions inherited from Fl_Image
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method.
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int).

## Public Attributes
int | alloc_array
| If non-zero, the object's data array is delete[]'d when deleting the object.
const uchar * | array
| Points to the start of the object's data array.

## Friends
class | Fl_GDI_Graphics_Driver
class | Fl_GDI_Printer_Graphics_Driver
class | Fl_Quartz_Graphics_Driver
class | Fl_Xlib_Graphics_Driver

## Additional Inherited Members
Static Public Attributes inherited from Fl_Image
static const int | ERR_FILE_ACCESS = -2
static const int | ERR_FORMAT = -3
static const int | ERR_NO_IMAGE = -1
Protected Member Functions inherited from Fl_Image
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current array pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it.
void | h (int H)
| Sets the current image height in pixels.
void | ld (int LD)
| Sets the current line data size in bytes.
void | w (int W)
| Sets the current image width in pixels.
Static Protected Member Functions inherited from Fl_Image
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

The Fl_RGB_Image class supports caching and drawing of full-color images with 1 to 4 channels of color information.

Images with an even number of channels are assumed to contain alpha information, which is used to blend the image with the contents of the screen.

Fl_RGB_Image is defined in <FL/Fl_Image.H>, however for compatibility reasons <FL/Fl_RGB_Image.H> should be included.

## Constructor & Destructor Documentation

## ◆ Fl_RGB_Image() [1/2]

Fl_RGB_Image::Fl_RGB_Image | ( | const uchar * | bits,
|  | int | W,
|  | int | H,
|  | int | D = `3`,
|  | int | LD = `0`
| ) |  |

The constructor creates a new image from the specified data.

The data array `bits` must contain sufficient data to provide `W` * `H` * `D` image bytes and optional line padding, see `LD`.

`W` and `H` are the width and height of the image in pixels, resp.

`D` is the image depth and can be:

- D=1: each uchar in `bits`[] is a grayscale pixel value
- D=2: each uchar pair in `bits`[] is a grayscale + alpha pixel value
- D=3: each uchar triplet in `bits`[] is an R/G/B pixel value
- D=4: each uchar quad in `bits`[] is an R/G/B/A pixel value

`LD` specifies the line data size of the array, see Fl_Image::ld(int). If `LD` is zero, then `W` * `D` is assumed, otherwise `LD` must be greater than or equal to `W` * `D` to account for (unused) extra data per line (padding).

The caller is responsible that the image data array `bits` persists as long as the image is used.

This constructor sets Fl_RGB_Image::alloc_array to 0. To have the image object control the deallocation of the data array `bits`, set alloc_array to non-zero after construction.

Parameters

  [in] | bits | The image data array.
  [in] | W | The width of the image in pixels.
  [in] | H | The height of the image in pixels.
  [in] | D | The image depth, or 'number of channels' (default=3).
  [in] | LD | Line data size (default=0).

See also
  Fl_Image::data(), Fl_Image::w(), Fl_Image::h(), Fl_Image::d(), Fl_Image::ld(int)

## ◆ Fl_RGB_Image() [2/2]

Fl_RGB_Image::Fl_RGB_Image | ( | const Fl_Pixmap * | pxm,
|  | Fl_Color | bg = `FL_GRAY`
| ) |  |

The constructor creates a new RGBA image from the specified Fl_Pixmap.

The RGBA image is built fully opaque except for the transparent area of the pixmap that is assigned the `bg` color with full transparency.

This constructor creates a new internal data array and sets Fl_RGB_Image::alloc_array to 1 so the data array is deleted when the image is destroyed.

## Member Function Documentation

## ◆ color_average()

void Fl_RGB_Image::color_average | ( | Fl_Color | c,
|  | float | i
| ) |  |
| virtual

The color_average() method averages the colors in the image with the FLTK color value c.

The i argument specifies the amount of the original image to combine with the color, so a value of 1.0 results in no color blend, and a value of 0.0 results in a constant image of the specified color.

An internal copy is made of the original image before changes are applied, to avoid modifying the original image.

Reimplemented from Fl_Image.

## ◆ copy()

Fl_Image * Fl_RGB_Image::copy | ( | int | W,
|  | int | H
| ) |  |
| virtual

The copy() method creates a copy of the specified image.

If the width and height are provided, the image is resized to the specified size. The image should be deleted (or in the case of Fl_Shared_Image, released) when you are done with it.

Reimplemented from Fl_Image.

## ◆ desaturate()

void Fl_RGB_Image::desaturate | ( |  | ) |
| virtual

The desaturate() method converts an image to grayscale.

If the image contains an alpha channel (depth = 4), the alpha channel is preserved.

An internal copy is made of the original image before changes are applied, to avoid modifying the original image.

Reimplemented from Fl_Image.

## ◆ draw()

void Fl_RGB_Image::draw | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | cx = `0`,
|  | int | cy = `0`
| ) |  |
| virtual

Draws the image with a bounding box.

Arguments `X,Y,W,H` specify a bounding box for the image, with the origin
(upper-left corner) of the image offset by the `cx` and `cy` arguments.

In other words: `fl_push_clip(X,Y,W,H)` is applied, the image is drawn with its upper-left corner at `X-cx,Y-cy` and its own width and height, `fl_pop_clip``()` is applied.

Reimplemented from Fl_Image.

## ◆ label() [1/2]

void Fl_RGB_Image::label | ( | Fl_Menu_Item * | m | ) |
| virtual

The label() methods are an obsolete way to set the image attribute of a widget or menu item.

Use the image() or deimage() methods of the Fl_Widget and Fl_Menu_Item classes instead.

Reimplemented from Fl_Image.

## ◆ label() [2/2]

void Fl_RGB_Image::label | ( | Fl_Widget * | widget | ) |
| virtual

The label() methods are an obsolete way to set the image attribute of a widget or menu item.

Use the image() or deimage() methods of the Fl_Widget and Fl_Menu_Item classes instead.

Reimplemented from Fl_Image.

## ◆ max_size() [1/2]

static size_t Fl_RGB_Image::max_size | ( |  | ) |
| inlinestatic

Returns the maximum allowed image size in bytes when creating an Fl_RGB_Image object.

See also
  void Fl_RGB_Image::max_size(size_t)

## ◆ max_size() [2/2]

static void Fl_RGB_Image::max_size | ( | size_t | size | ) |
| inlinestatic

Sets the maximum allowed image size in bytes when creating an Fl_RGB_Image object.

The image size in bytes of an Fl_RGB_Image object is the value of the product w() * h() * d(). If this product exceeds size, the created object of a derived class of Fl_RGB_Image won't be loaded with the image data. This does not apply to direct RGB image creation with Fl_RGB_Image::Fl_RGB_Image(const uchar *bits, int W, int H, int D, int LD). The default max_size() value is essentially infinite.

## ◆ uncache()

void Fl_RGB_Image::uncache | ( |  | ) |
| virtual

If the image has been cached for display, delete the cache data.

This allows you to change the data used for the image and then redraw it without recreating an image object.

Reimplemented from Fl_Image.

The documentation for this class was generated from the following files:

- Fl_Image.H
- Fl_Image.cxx